(function() {
	var special = jQuery.event.special, uid1 = 'D' + (+new Date()), uid2 = 'D' + (+new Date() + 1);
	special.scrollstart = {
		setup : function() {
			var timer, handler = function(evt) {
				var _self = this, _args = arguments;
				if (timer) {
					clearTimeout(timer);
				} else {
					evt.type = 'scrollstart';
					jQuery.event.handle.apply(_self, _args);
				}
				timer = setTimeout(function() {
					timer = null;
				}, special.scrollstop.latency);
			};
			jQuery(this).bind('scroll', handler).data(uid1, handler);
		},
		teardown : function() {
			jQuery(this).unbind('scroll', jQuery(this).data(uid1));
		}
	};
	special.scrollstop = {
		latency : 300,
		setup : function() {
			var timer, handler = function(evt) {
				var _self = this, _args = arguments;
				if (timer) {
					clearTimeout(timer);
				}
				timer = setTimeout(function() {
					timer = null;
					evt.type = 'scrollstop';
					jQuery.event.handle.apply(_self, _args);
				}, special.scrollstop.latency);
			};
			jQuery(this).bind('scroll', handler).data(uid2, handler);
		},
		teardown : function() {
			jQuery(this).unbind('scroll', jQuery(this).data(uid2));
		}
	};
})(); 

(function($) {
    $.fn.fastClick = function(handler) {
        return $(this).each(function() {
            $.FastButton($(this)[0], handler);
        });
    };

    $.FastButton = function(element, handler) {
        var startX, startY;

        var reset = function() {
            $(element).unbind('touchend');
            $("body").unbind('touchmove.fastClick');
        };

        var onClick = function(event) {
            event.stopPropagation();
            reset();
            handler.call(this, event);

            if (event.type === 'touchend') {
                $.clickbuster.preventGhostClick(startX, startY);
            }
        };

        var onTouchMove = function(event) {
            if (Math.abs(event.originalEvent.touches[0].clientX - startX) > 10 || Math.abs(event.originalEvent.touches[0].clientY - startY) > 10) {
                reset();
            }
        };

        var onTouchStart = function(event) {
            event.stopPropagation();

            $(element).bind('touchend', onClick);
            $("body").bind('touchmove.fastClick', onTouchMove);

            startX = event.originalEvent.touches[0].clientX;
            startY = event.originalEvent.touches[0].clientY;
        };

        $(element).bind({
            touchstart : onTouchStart,
            click : onClick
        });
    };

    $.clickbuster = {
        coordinates : [],

        preventGhostClick : function(x, y) {
            $.clickbuster.coordinates.push(x, y);
            window.setTimeout($.clickbuster.pop, 2500);
        },

        pop : function() {
            $.clickbuster.coordinates.splice(0, 2);
        },

        onClick : function(event) {
            var x, y, i;
            for ( i = 0; i < $.clickbuster.coordinates.length; i += 2) {
                x = $.clickbuster.coordinates[i];
                y = $.clickbuster.coordinates[i + 1];
                if (Math.abs(event.clientX - x) < 25 && Math.abs(event.clientY - y) < 25) {
                    event.stopPropagation();
                    event.preventDefault();
                }
            }
        }
    };

    $(function() {
        if (document.addEventListener) {
            document.addEventListener('click', $.clickbuster.onClick, true);
        } else if (document.attachEvent) {
            // for IE 7/8
            document.attachEvent('onclick', $.clickbuster.onClick);
        }
    });
})(jQuery);

(function($){

        /**
         * Copyright 2012, Digital Fusion
         * Licensed under the MIT license.
         * http://teamdf.com/jquery-plugins/license/
         *
         * @author Sam Sehnert
         * @desc A small plugin that checks whether elements are within
         *                 the user visible viewport of a web browser.
         *                 only accounts for vertical position, not horizontal.
         */
        $.fn.visible = function(partial,hidden){
                
            var $t                                = $(this).eq(0),
                    t                                = $t.get(0),
                    $w                                = $(window),
                    viewTop                        = $w.scrollTop(),
                    viewBottom                = viewTop + $w.height(),
                    _top                        = $t.offset().top,
                    _bottom                        = _top + $t.height(),
                    compareTop                = partial === true ? _bottom : _top,
                    compareBottom        = partial === true ? _top : _bottom,
                    clientSize                = hidden === true ? t.offsetWidth * t.offsetHeight : true;
                
                return !!clientSize && ((compareBottom <= viewBottom) && (compareTop >= viewTop));
    };
    
})(jQuery);

